/*---------------------------------------------------------------------------
oOP IG 洫ƪA
---------------------------------------------------------------------------*/
//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <mmsystem.h>
#include <time.h>
#pragma hdrstop


#include 
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#pragma resource "*.dfm"
TfmMain *fmMain;


SIM_REC_STRUCT        SimPlay;
SIM_IOS1_STRUCT       SimIos;
SIM_SVR1_DATA_STRUCT  Data2Client;
SIM_SVR1_ACK_STRUCT   AckFromClient;
int m_iPlaneId;
int bEnableDebug;

//pɯ
UINT hTimer;
DWORD t1, t2;
int iCount;
double dt;
clock_t start, end;

//---------------------------------------------------------------------------
AnsiString m_Caption;
void __fastcall CreateTimer(DWORD dwClock);
void __fastcall CaculateFreq();
//---------------------------------------------------------------------------
void CALLBACK mmTimerProc(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
      start = clock();

      //ŪUg䪺AliveA
      IPCRead(&SimIos, IOS_IOS1_OFFSET, sizeof(SimIos), m_iPlaneId);
      if(SimIos.Status.iSimStatus == PLAYBACK)
      {
         IPCRead(&SimPlay, HOST_REC_OFFSET, sizeof(SimPlay), m_iPlaneId);
         memcpy(&Data2Client.SimIgTgt, &SimPlay.SimIgTgt, sizeof(Data2Client.SimIgTgt));
      }
      else
      {
         IPCRead(&Data2Client, HOST_SVR1_DATA_OFFSET, sizeof(Data2Client), m_iPlaneId);
      }

      TList *pList = fmMain->Clients->LockList();
      try
      {
         for(int X = 0; X < pList->Count; X++)
         {
            TClient *pClient = (TClient *)pList->Items[X];
            try
            {
               pClient->Thread->Connection->WriteBuffer(&Data2Client, sizeof(Data2Client), true);
            }
            catch(Exception &E)
            {
               pClient->Thread->Terminate();
            }
         }
      }
      __finally
      {
         fmMain->Clients->UnlockList();
      }

      Data2Client.iSvr1Alive = rand();
      IPCWrite(&Data2Client, HOST_SVR1_DATA_OFFSET, sizeof(Data2Client), m_iPlaneId);

      CaculateFreq();

      end = clock();
      double dRT = 0.1*(end - start);
      AnsiString S = AnsiString().sprintf("The time was: %f",  dRT / CLOCKS_PER_SEC);
      fmMain->Writelog(S);
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetFileVersion(AnsiString FileName)
{
   int   iVerInfoSize;
   char   *pBuf;
   AnsiString   asVer;
   VS_FIXEDFILEINFO   *pVsInfo;
   unsigned int iFileInfoSize = sizeof(VS_FIXEDFILEINFO);

   iVerInfoSize = GetFileVersionInfoSize(FileName.c_str(), NULL);
   if(iVerInfoSize != 0)
   {
      pBuf = new char[iVerInfoSize];
      if(GetFileVersionInfo(FileName.c_str(), 0, iVerInfoSize, pBuf))
      {
         if(VerQueryValue(pBuf, "\\", (void **)&pVsInfo, &iFileInfoSize))
         {
            asVer  = "V";
            asVer += IntToStr(HIWORD(pVsInfo->dwFileVersionMS)) + ".";
            asVer += IntToStr(LOWORD(pVsInfo->dwFileVersionMS)) + " Build ";
            asVer += IntToStr(LOWORD(pVsInfo->dwFileVersionLS));
         }
      }
      delete[] pBuf;
   }
   return asVer;
}
//---------------------------------------------------------------------------
//pɯ
void __fastcall CaculateFreq()
{
   t2 = timeGetTime();
   double dt = (t2-t1)*1.0;
   iCount++;
   if(dt >= 1000.0)
   {
      dt = (iCount*1000.0)/dt;
      fmMain->Caption = m_Caption + "..." + AnsiString().sprintf("FR=%5.1f Hz", dt);
      iCount = 0;
      t1 = t2;
   }
}
//---------------------------------------------------------------------------

void __fastcall CreateTimer(DWORD dwClock)
{
   //Create Multimedia Timer
   if((hTimer = timeSetEvent(1000/dwClock, 1, mmTimerProc, 0, TIME_PERIODIC))==NULL)
   {
      ShowMessage("䴩 1 ms pɾ");
      ExitProcess(1);
   }
}
//---------------------------------------------------------------------------

__fastcall TfmMain::TfmMain(TComponent* Owner)
        : TForm(Owner)
{
   memset(&Data2Client, 0, sizeof(Data2Client));
   memset(&AckFromClient, 0, sizeof(AckFromClient));
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormCreate(TObject *Sender)
{
   char Msg[256];

int a = sizeof(SIM_SVR1_DATA_STRUCT);
int b = sizeof(Data2Client);
int c = sizeof(SIM_SVR1_ACK_STRUCT);
int d = sizeof(AckFromClient);

   if(ParamCount() < 4)
   {
      AnsiString S = ExtractFileName(ParamStr(0));
      AnsiString Msg = AnsiString().sprintf("ϥΤ覡: %s s IP s 洫ϦW", S.c_str());
      MessageDlg(Msg, mtInformation, TMsgDlgButtons() << mbOK, 0);
      Application->Terminate();
      ExitProcess(1);
   }

   m_Caption = AnsiString().sprintf("%s(Ver:%s)", Caption, GetFileVersion(Application->ExeName));
#ifdef PLATFORM_WIN
   m_Caption = m_Caption + "";
#else
   m_Caption = m_Caption + "";
#endif

   m_iPlaneId = ParamStr(1).ToInt();

   if(CreateShareMemory(ParamStr(4).c_str(), MEM_TOTAL_SIZE, 0) != SM_OK)
   {
      if(OpenShareMemory(ParamStr(4).c_str(), 0) != SM_OK)
      {
         Application->MessageBoxA("Lk}SM洫", "T", MB_OK);
         Application->Terminate();
         ExitProcess(1);
      }

   }

   CreateTimer(64);

   Clients = new TThreadList();

   IdTCPServer1->Bindings->Clear();
   TIdSocketHandle *Binding = IdTCPServer1->Bindings->Add();
   Binding->IP = ParamStr(2);
   Binding->Port = ParamStr(3).ToInt();
   IdTCPServer1->Active = true;

   struct hostent *ht;
   int addr = inet_addr(Binding->IP.c_str());
   int type = AF_INET;
   ht = gethostbyaddr((char *)&addr, sizeof(int), type);
   AnsiString S = AnsiString().sprintf(">>> Server(%s(%s):%d) #1 is ready...",
                  ht->h_name, inet_ntoa(*(struct in_addr *)ht->h_addr), Binding->Port);
   Writelog(S);
}
//---------------------------------------------------------------------------
                
void __fastcall TfmMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
   if(Key == VK_ESCAPE)
   {
      Close();
   }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::IdTCPServer1Connect(TIdPeerThread *AThread)
{
   AnsiString txt;
   AnsiString PeerIP   = AThread->Connection->Binding->PeerIP;
   AnsiString HostName = GStack->WSGetHostByAddr(PeerIP);
   TDateTime TimeConnected = Now();

      TClient *pClient = new TClient;
      pClient->PeerIP     = PeerIP;
      pClient->HostName   = HostName;
      pClient->Id         = 1;
      pClient->Connected  = TimeConnected;
      pClient->LastAction = pClient->Connected;
      pClient->Thread     = AThread;
      AThread->Data = (TObject *)pClient;
      Clients->Add(pClient);

   char ABuffer[3] = {0};
   AThread->Connection->ReadBuffer(ABuffer, 2);
   
   AckFromClient.iNetIgAlive = 1;
   IPCWrite(&AckFromClient, HOST_SVR1_ACK_OFFSET, sizeof(AckFromClient), m_iPlaneId);

   AnsiString text = AnsiString().sprintf("%s(%s)  %s Wu!...",
                     HostName, PeerIP, DateTimeToStr(TimeConnected));
   Writelog(text);
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::IdTCPServer1Disconnect(TIdPeerThread *AThread)
{
   TClient *pClient = NULL;
   AnsiString Msg;

   pClient = (TClient *)AThread->Data;

   AckFromClient.iNetIgAlive = 0;
   IPCWrite(&AckFromClient, HOST_SVR1_ACK_OFFSET, sizeof(AckFromClient), m_iPlaneId);

	TDateTime now = TDateTime::CurrentDateTime();
   Msg = AnsiString().sprintf(">>> %s(%s)  %s u...", pClient->HostName, pClient->PeerIP, DateTimeToStr(now));
   Writelog(Msg);

   try
   {
      Clients->LockList()->Remove(pClient);
   }
   __finally
   {
      Clients->UnlockList();
   }
   delete pClient;
   AThread->Data = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::IdTCPServer1Execute(TIdPeerThread *AThread)
{
   TClient *pClient = NULL;

   if(!AThread->Terminated && AThread->Connection->Connected())
   {
      pClient = (TClient *)AThread->Data;
      if(pClient->Id != 0)
      {
         try
         {
            AThread->Connection->ReadBuffer(&AckFromClient, sizeof(AckFromClient));
            AckFromClient.iNetIgAlive = 1;
            IPCWrite(&AckFromClient, HOST_SVR1_ACK_OFFSET, sizeof(AckFromClient), m_iPlaneId);
         }
         catch(Exception &E)
         {
            AnsiString S = AnsiString().sprintf("LkӦ%sơAN_u...", pClient->PeerIP);
            Writelog(S);
            AThread->Terminate();
         }
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::Writelog(String log)
{
   if(mmLog->Lines->Count > 15)
   {
      mmLog->Lines->Clear();
   }
   mmLog->Lines->Add(log);
}
//---------------------------------------------------------------------------

void __fastcall TfmMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   Application->ProcessMessages();

   timeKillEvent(hTimer);

   Application->ProcessMessages();

   IdTCPServer1->Active = false;

   TList *pList = Clients->LockList();
   try
   {
      for(int X = 0; X < pList->Count; X++)
      {
         delete (TClient *)pList->Items[X];
      }
   }
   __finally
   {
      Clients->UnlockList();
   }
   delete Clients;
}
//---------------------------------------------------------------------------


